------------------------------------------------------------------------------------------------------------------
-- Quickslots library
-- By Musje
-- 
-- This library is no longer a "public" library. 
-- Please ask my permission if you want to use the library or parts of it. 
-- Using my library without permission may cause your plugin to break. 
-- Do NOT, under any circumstance, include this library with your plugin as a download. 
-- I do not want my plugins breaking because of anyone telling people to place an older version over it. 
-- 
-- For more info and reasons, please visit http://forums.lotro.com/showthread.php?t=349988
-- 
-- The usage lines above each function are for my own use and do not mean you can use it at will. 
------------------------------------------------------------------------------------------------------------------


-----------------------------------------------------------------------------------------------
-- Usage: Musje.Library.quickslot(<name of the quickslot>,<unique number of the quickslot>); --
-----------------------------------------------------------------------------------------------
function quickslot(name,number)
	name.lock = false
	name:SetAllowDrop(true)
	name:SetWantsKeyEvents(true)
	name.MouseDown = function(sender,args)
		setquickslotmouse(number);
	end
	name.DragLeave = function(sender,args)
		if (getquickslotmouse() == number) and (name.lock == false) then
			name:SetShortcut(nil);
		end
		setquickslotmouse(0);
		setdestination(0)
		cyclevisible();
	end
	name.DragEnter = function(sender,args)
		setdestination(number)
	end
	--name.DragDrop = function(sender,args) -- event is never fired, causes a small bug when dragging and dropping stuff without even leaving the specific quickslot
	--	Message("Quickslot "..number);
	--	quickslotmouse = 0;
	--end
--	name.ShortcutChanged = function(sender,args)
--		if quickslotautosave then
--			settings.quickslot[number] = savequickslot(name,number);
--		end
--	end
end


-----------------------------------------------------------
-- Usage: Musje.Library.unlock(<name of the quickslot>); --
-----------------------------------------------------------
function lock(name)
	name:SetAllowDrop(false)
	name.lock = true
end

-----------------------------------------------------------
-- Usage: Musje.Library.unlock(<name of the quickslot>); --
-----------------------------------------------------------
function unlock(name)
	name:SetAllowDrop(true)
	name.lock = false
end


--------------------------------------------------------------------------------------------
-- Usage: settings.quickslot[number] = Musje.Library.savequickslot(quickslotname,number); --
--------------------------------------------------------------------------------------------
function savequickslot(name,number)
	Quickslots = { };
	local shortcut = name:GetShortcut();
	local data = shortcut:GetData();
	local type = shortcut:GetType(); 
	Quickslots[number] = { };
	Quickslots[number].Type = type
	Quickslots[number].Data = data
	return Quickslots[number];
end

-----------------------------------------------------------------------------------------------------------------------
-- Usage: Musje.Library.PSetShortcut(quickslotname,Musje.Library.loadquickslot(settings.Quickslots[number],number)); --
-----------------------------------------------------------------------------------------------------------------------
function loadquickslot(data,number)
	if (type(data)~="table")then
		return;
	end
	shortcut = { };
	shortcut = data
	if shortcut ~= nil then
		shortcut = Turbine.UI.Lotro.Shortcut(shortcut.Type,shortcut.Data);
	end
	return shortcut;
end
function PSetShortcut(quickslot,data)
	pcall(function () quickslot:SetShortcut(data) end)
end

