import "Turbine";
import "Turbine.Gameplay";
import "Turbine.UI";
import "Turbine.UI.Lotro";
import "Turbine.Utils";
import "Turbine.Debug.Table";
import "Musje.Library.quickslots";
import "Musje.MouseGestures.Gestures";

MouseGestures = { };
MouseGestures.data = { };
MouseGestures.data.loading = true;
MouseGestures.data.quickslot = { };
MouseGestures.data.quickslots = { };
MouseGestures.elements = { };
MouseGestures.elements.GestureBar = { };
MouseGestures.elements.GestureBar.quickslot = { };
-- Create invisible window from which to GetMousePosition. Thanks to ScrappyTheGreat for this idea
NewWindow("hidden");

shellCommand = Turbine.ShellCommand()
function shellCommand:Execute(command, arguments) -- chatcommands
	if arguments == "help" then
		Message("Mousegestures possible arguments:");
		Message("help: Shows this text.");
		Message("setup <[on/off]>: Enables or disables setup mode.");
		Message("gestures <[on/off]>: Enables or disables gestures.");
		Message("save [<filename>]: Saves the current settings in the speicified or default file.");
		Message("load [<filename>]: Loads settings in the specified or default file.");
	elseif (arguments == "setup") or (arguments == "setup ") then
		if (MouseGestures.data.setup == true) then
			MouseGestures.data.setup = false;
			setsetup(false);
			Message("Setup disabled.");
		else
			MouseGestures.data.setup = true;
			setsetup(true);
			Message("Setup enabled");
		end
	elseif arguments == "setup on" then
		MouseGestures.data.setup = true;
		setsetup(true);
		Message("Setup enabled.");
	elseif arguments == "setup off" then
		MouseGestures.data.setup = false;
		setsetup(false);
		Message("Setup disabled.");
	elseif (arguments == "gestures") or (arguments == "gestures ") then
		if (MouseGestures.data.gestures == true) then
			MouseGestures.data.gestures = false;
			Message("Gestures disabled.");
		else
			MouseGestures.data.gestures = true;
			Message("Gestures enabled.");
		end
	elseif arguments == "gestures on" then
		MouseGestures.data.gestures = true;
		Message("Gestures enabled.");
	elseif arguments == "gestures off" then
		MouseGestures.data.gestures = false;
		Message("Gestures disabled.");
	elseif (arguments == "save") or (arguments == "save ") then
		Message("Saving default settings...")
		save(nil,false);
	elseif (string.sub(arguments,1,4) == "save") then
		filename = string.sub(arguments,6,-1)
		Message("Saving settings: '"..filename.."'...");
		save(filename,false);
	elseif (arguments == "load") or (arguments == "load ") then
		Message("Loading default settings...");
		load();
	elseif (string.sub(arguments,1,4) == "load") then
		filename = string.sub(arguments,6,-1)
		Message("Loading settings: '"..filename.."'...");
		load(filename);
	else
		Message("Usage: /MouseGestures [help | setup [<on/off>] | gestures [<on/off>] | save [<filename>] | load [<filename>]");
	end
end
Turbine.Shell.AddCommand('mousegestures', shellCommand)
Turbine.Shell.AddCommand('mg', shellCommand)

MouseGestures.data.load = Turbine.PluginData.Load(Turbine.DataScope.Character,"MouseGestures");
MouseGestures.data.runonce = Turbine.PluginData.Load(Turbine.DataScope.Account,"MouseGestures");
if (type(MouseGestures.data.load)=="table")then
	if (MouseGestures.data.load.version == nil) then
		MouseGestures.data.load.version = 1;
	end
end

if (type(MouseGestures.data.load)~="table") then
	LoadDefaults();
	if MouseGestures.data.runonce == nil then
		Message("Welcome to MouseGestures.");
		Message("It appears that this is the first time you run this plugin, default settings have been loaded.");
		Message("Type '/MouseGestures help' for more info about the plugin.");
	end
	MouseGestures.data.load = nil;
	MouseGestures.data.loading = false;
elseif (MouseGestures.data.load.version < 2.0) then
	LoadDefaults();
	for i=1,9 do
		Musje.Library.PSetShortcut(MouseGestures.elements.GestureBar.quickslot[i],Musje.Library.loadquickslot(MouseGestures.data.load.Quickslots[i],i));
	end
	Message("Savedata from version 1.x found. Your quickslots have been loaded.");
	MouseGestures.data.load = nil;
	MouseGestures.data.loading = false;
else
	if (MouseGestures.data.load.version ~= 2.25) then
		Message("Savedata from version "..MouseGestures.data.load.version.." found. The savedata will be automatically updated to the current version on the next save.");
	end
	NewWindow("GestureBar");
	Makequickslots();
	for i=1,9 do
		Musje.Library.PSetShortcut(MouseGestures.elements.GestureBar.quickslot[i],Musje.Library.loadquickslot(MouseGestures.data.load.quickslot[i],i));
	end
	MouseGestures.data.setup=MouseGestures.data.load.setup;
	MouseGestures.data.gestures=MouseGestures.data.load.gestures;
	if (MouseGestures.data.setup == false) then
		setsetup(false);
	else
		MouseGestures.data.setup = true;
		setsetup(true);
	end
	MouseGestures.data.load = nil;
	MouseGestures.data.loading = false;
end

import "Musje.MouseGestures.Direction";
